import type { RouteRecordRaw } from "vue-router";
import Middleware from "@/js/contexts/shared/models/Middleware";
import { Permission } from "@/js/contexts/shared/models/Permission";

const routes: RouteRecordRaw[] = [
  {
    name: "links",
    path: "/links",
    component: () => import("@/js/contexts/links/ui/pages/LinksListPage.vue"),
    meta: {
      middleware: [Middleware.auth],
      permissions: [Permission.LINKS_VIEW],
    },
    children: [
      {
        name: "links.create",
        path: "/links/create",
        component: () => import("@/js/contexts/links/ui/pages/LinksCreatePage.vue"),
        meta: {
          middleware: [Middleware.auth],
          permissions: [Permission.LINKS_CREATE],
        },
      },
      {
        name: "links.update",
        path: "/links/:id",
        component: () => import("@/js/contexts/links/ui/pages/LinksUpdatePage.vue"),
        meta: {
          middleware: [Middleware.auth],
          permissions: [Permission.LINKS_UPDATE],
        },
      },
      {
        name: "links.analytics",
        path: "/links/:id/analytics",
        component: () => import("@/js/contexts/links/ui/pages/LinksAnalyticsPage.vue"),
        meta: {
          middleware: [Middleware.auth],
          permissions: [Permission.LINKS_VIEW],
        },
      },
    ],
  },
];

export default routes;
